/*
 *   tiff16/256F -> tiff32kF  ϊvO ''
 *                  (C)1993,1994  By N.Takahashi
 *
 *      ver0.61 1994/02/06   pbgTifff[^ɑΉ
 *      ver0.6  1994/02/05   VTiff֐֕ύX(k`ɑΉ)
 *      ver0.5  1994/01/13   ēxϊ|`̍
 *      ver0.4  1994/01/05   ChJ[hΉoOCetc.
 *      ver0.3  1994/01/04   ϊ|`̍
 *      ver0.2  1994/01/04   t@C(zousan.c tiff.c graph.c)
 *      ver0.1  1993/11/11   
 */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <fcntl.h>
#include <EGB.h>

#include "tiff2.h"		/* gCuI𔃂ȂƂȂ(^^;) */
#include "graph.h"


/* Compile @ */
/*   hcc zousan tiff2 graph -stack 200000   */


/* Prototype function */
void sum_ydata( int *ydt, int *sum, int *cnt );
void ren_file( void );
int exp_wild( char *path, char *file, char *dpath, char *dfile );
int isoldfile( char *fname );
void split_path( char *path, char *file, char *wd );
void sum_gdata256( int x, int y, int *cg, int *cr, int *cb );
void sum_gdata16( int x, int y, int *cg, int *cr, int *cb );
void title( void );
void usage( void );
int zousan( void );
void make_color( int *b, int *r, int *g, int b1, int r1, int g1, int hi );
int convert32k( void );
void adj_palette( char *pal, int col );


/* }N` */
#define	CVCR(b,r,g)	((-(b)*816+(r)*5020-(g)*4203)/10000)
#define CVCB(b,r,g)	(((b)*5020-(r)*1812-(g)*3214)/10000)
#define CVY(b,r,g)	(((b)*1446+(r)*2955+(g)*5899)/10000)
#define CVY2(b,r,g)	(((b)*1446+(r)*2955+(g)*5899))

#define CVB(cr,cb,y) ((y)*9719+(cr)*487+(cb)*17201)
#define CVR(cr,cb,y) ((y)*9707+(cr)*14021-(cb)*516)
#define CVG(cr,cb,y) ((y)*9707-(cr)*7142-(cb)*3957)

#define	ATTR		(_A_NORMAL|_A_RDONLY|_A_HIDDEN)


/* Global variable */

PALETTE16 *Pal16;
PALETTE256 *Pal256;

char *Gdata,*Gpal;	/* 摜f[^&pbg */
int SizX;			/* TCY */
int SizY;			/* cTCY */
int Gcol=0;			/* F     */
char *Ddata;		/* ϊ摜f[^ */

int Blur=0;			/*  Blur = 0 - 100 (Blur)          */
int Tone=0;			/*  Tone = 0 - 100 (Tone of color) */

int BlurF=0,ToneF=0,DispF=0;		/* IvVtO */
int CompF=0;

int DirX[4]={0,1,0,-1};
int DirY[4]={-1,0,1,0};

void (*Sum_gdata)( int x, int y, int *cg, int *cr, int *cb );

char *Srcfile=NULL;
char *Dstfile=NULL;

#define PATH_MAX	128
#define FILE_MAX	16
char SPath[PATH_MAX];		/* ܲ޶ޓWJɎgp */
char SFile[FILE_MAX];
char DPath[PATH_MAX];
char DFile[FILE_MAX];

int WildF=0,DDirF=0;		/* ܲ޶-ނgpł悤ɂ
								\䂪GɂȂĂ܂ */

char Nowfile[128];			/* ݤ̃t@C */


/* gp@ */
void usage( void ) {
	printf( "usage: run386 zousan.exp [option] srcTiff16/256 [dstTiff]\n" );
	printf( "        -b<val>  (Blur)          ,val = 0 - 100\n" );
	printf( "        -t<val>  (Tone of color) ,val = 0 - 100\n" );
	printf( "        -d       (Display only)\n" );
	printf( "        -c       (Compress Tiff file)\n\n" );
	printf( "       default:  16color = -b0 , -t20\n" );
	printf( "                256color = -b0 , -t2\n" );
	exit( 255 );
}


/* ^Cg */
void title( void ) {
	printf( "Tiff16/256F -> Tiff32kF  ϊvO ''\n" );
	printf( "                        (C)1993,1994  By N.Takahashi\n\n" );
}


/* C */
void main( int argc, char *argv[] ) {
int i;

	title();
	
	if( argc==1 )
		usage();
	for( i=1; i<argc; i++ ) {					/* IvVWJ */
		if( argv[i][0]=='-' || argv[i][0]=='/' )
			switch( argv[i][1] ) {				/* 蔲Ă(^^;) */
				case 'b':
				case 'B':
					Blur=atoi( argv[i]+2 );
					BlurF=1;
					break;
				case 't':
				case 'T':
					Tone=atoi( argv[i]+2 );
					ToneF=1;
					break;
				case 'd':
				case 'D':
					DispF=1;
					break;
				case 'c':
				case 'C':
					CompF=1;
					break;
				default:
					usage();
					break;
			}
		else {
			if( Srcfile==NULL )
				Srcfile=argv[i];
			else
				Dstfile=argv[i];
		}
	}
	if( Srcfile==NULL )
		usage();

	isoldfile( NULL );		/* ̃Zbg */
							/* xϊȂ悤ɂ邽߂̏ */
	
	strcpy( SPath, Srcfile );
	split_path( SPath, SFile, "*.TIF" );
	if( strchr( SFile, '*' )!=NULL || strchr( SFile, '?' )!=NULL ) {
		WildF=1;
	}
	
	if( Dstfile==NULL ) {		/* w肳ĂȂƂ */
		strcpy( DPath, SPath );
		*DFile='\0';
	}
	else {						/* t@Cw肳ĂƂ */
		strcpy( DPath, Dstfile );
		split_path( DPath, DFile, "" );
		if( WildF ) {
			strcat( DPath, DFile );
			strcat( DPath, "\\" );
			*DFile='\0';
		}
		if( *DFile=='\0' )			/* fBNĝ݂̂Ƃ */
			DDirF=1;
	}
	
	exp_wild( SPath, SFile, DPath, DFile );
}


/* ChJ|hWJ */
int exp_wild( char *path, char *file, char *dpath, char *dfile ) {
struct find_t fb;
int spl,dpl;
char *c;
	
	spl=strlen( path );
	dpl=strlen( dpath );
	strcat( path, file );
	if( _dos_findfirst( path, ATTR, &fb )==0 ) {
		do {
			path[spl]='\0';
			dpath[dpl]='\0';
			strcat( path, fb.name );
			
			if( isoldfile( path ) ) {
						/* xϊȂ悤ɂ邽 */
			
				sprintf( Nowfile, "%-12s : ", fb.name );
				Srcfile=path;
				Dstfile=dpath;
				if( *dfile=='\0' ) {	/* t@Cw肳ĂȂƂ */
					if( DDirF ) {		/* fBNĝ݂̂Ƃ */
						strcat( dpath, fb.name );
						zousan();
					}
					else {				/* w肳ĂȂƂ */
						strcat( dpath, fb.name );
						if( ( c=strrchr( dpath, '.' ) )!=NULL ) {
							*c='\0';
						}
						strcat( dpath, ".$$$" );
						if( zousan()==0 )
							ren_file();
					}
				}
				else {					/* t@Cw肳ĂƂ */
					strcat( dpath, dfile );
					zousan();
				}
			}
		} while( _dos_findnext( &fb )==0 );
		return( 0 );
	}
	else {
		printf( "%-12s : t@C܂\n", _strupr(file) );
	}
	return( 1 );
}


/* ^CX^vƃVXe^CƂ̔r */
/* gpOɊZbgĂ => isoldfile( NULL ) */
int isoldfile( char *fname ) {
static unsigned int sdate=0, stime=0;
struct dosdate_t sdt;
struct dostime_t stm;
unsigned int fdt,ftm;
int hd;
	
	if( fname==NULL ) {
		_dos_getdate( &sdt );
		sdate=((sdt.year-1980)<<9)+(sdt.month<<5)+sdt.day;
		_dos_gettime( &stm );
		stime=(stm.hour<<11)+(stm.minute<<5)+(stm.second>>1);
	}
	else {
		if( _dos_open( fname, _O_RDONLY, &hd )!=0 )
			return( -1 ); 
		_dos_getftime( hd, &fdt, &ftm );
		_dos_close( hd );
		if( fdt<sdate || (fdt==sdate && ftm<stime) )
			return( 1 );
	}
	return( 0 );
}


/* t@Č */
void ren_file( void ) {
char path[128],*c;
									/* dst.$$$  dst.TIF  */
									/* src.TIF  src.$IF  */
	strcpy( path, Srcfile );
	if( ( c=strrchr( path, '.' ) )!=NULL ) {
		*c='\0';
	}
	strcat( path, ".$IF" );
	rename( Srcfile, path );

	strcpy( path, Dstfile );
	if( ( c=strrchr( path, '.' ) )!=NULL ) {
		*c='\0';
	}
	strcat( path, ".TIF" );
	rename( Dstfile, path );
}


/* o`sgƃt@Co */
void split_path( char *path, char *file, char *wd ) {
char *c,*c2;

	if( ( c=strrchr( path, ':' ) )==NULL ) {
		c=path;
	}
	if( ( c2=strrchr( c, '\\' ) )==NULL ) {
		c2=c;
	}
	if( *c2==':' || *c2=='\\' ) {
		if( *(c2+1)!='\0' ) {
			strcpy( file, c2+1 ); 
			*(c2+1)='\0';
		}
		else
			strcpy( file, wd ); 
	}
	else {
		strcpy( file , path );
		strcpy( path , "" );
	}
									/* '.' , '..' ΍ */
	if( strcmp( file, "." )==0 || strcmp( file, ".." )==0 ) {
		strcat( path, file );
		strcat( path, "\\" );
		strcpy( file, wd ); 
	}
}


/* 񃁃C */
int zousan( void ) {
Tiff *tp;
int rt;

	tp=Tiff_new();
												/* Tiff`[h */
	rt=Tiff_load( Srcfile, tp );
	if( rt!=Tiff__OK ) {
		printf( "%s%s\n", Nowfile, Tiff_err[rt] );
		return( 1 );
	}
	Tiff_decompress( tp );			/* kĂꍇWJ */
	Tiff_make_palette( tp );		/* pbgȂꍇɍ쐬 */
	
	Tiff_getgraph( &SizX, &SizY, &Gcol, &Gdata, &Gpal, tp );
											/* Fɂݒ */
	switch( Gcol ) {
		case 256:
			if( BlurF==0 )			/* ftHgl */
				Blur=0;
			if( ToneF==0 )
				Tone=2;
			Pal256=(PALETTE256 *)Gpal;
			Sum_gdata=sum_gdata256;
			break;
		case 16:
			if( BlurF==0 )
				Blur=0;
			if( ToneF==0 )
				Tone=20;
			Pal16=(PALETTE16 *)Gpal;
			Sum_gdata=sum_gdata16;
			break;
		default:
			printf( "%sȂf[^`ł\n", Nowfile );
			return( 1 );
	}

	if( Blur<0 )
		Blur=0;
	if( Blur>100 )
		Blur=100;
	if( Tone<0 )
		Tone=0;
	if( Tone>100 )
		Tone=100;
	
	adj_palette( Gpal, Gcol );		/* pbgf[^̒ */
									/* Tiff_load̃pbgf[^ͤ
									   ̂܂܂ł͎gɂ           */

	if( (Ddata=(char *)malloc( SizX*SizY/2 ))==NULL ) {
		printf( "܂\n" );
		Tiff_delete( tp );
		return( 1 );
	}
										/* 32KFϊ */
	if( convert32k() ) {
		printf( "f܂%*c\n", 60, 0x20 );
		G_dosterm();
		exit( 1 );
	}
										/* fBXvC\ */
	if( DispF ) {
		G_screen( 10, 0 );				/* 320*240 3F */
		G_screen( 10, 1 );
		G_enlarge( 2, 2, 0, 0, 320, 240 );
		G_active( 1, 3, 1 );
		G_put( 0,0, SizX/2-1,SizY/2-1, Ddata );
		_getch();						/* L[͂L܂ő҂ */
		G_dosterm();					/* DOSʂɖ߂ */
		Tiff_delete( tp );
		free( Ddata );
		return( 1 );
	}
										/* Tiff`Z[u */
	if( Dstfile!=NULL && !DispF ) {
		Tiff_delete( tp );
		tp=Tiff_new();
		Tiff_setgraph( tp, SizX/2, SizY/2, 32768, Ddata, NULL );
		if( CompF )
			Tiff_compress( tp );		/* -c w莞Ƀf[^k */
		rt=Tiff_save( Dstfile, tp );
		if( rt!=0 ) {
			printf( "%s%s\n", Nowfile, Tiff_err[rt] );
			Tiff_delete( tp );
			return( 1 );
		}
	}
	Tiff_delete( tp );
	return( 0 );
}


/* RFϊ */
int convert32k( void ) {
int x,y,a,b,hi,bc,bcc;
int cc,cg,cr,cb;
int yc,yg,yr,yb;
int g0,r0,b0;
int xx,yy,xd,yd;
int ydt[16];

	for( y=0; y<SizY-1; y+=2 ) {
		if( (y&31)==0 ) {
			printf( "%sϊł(%d)\r", Nowfile, y*100/SizY );
		}
		if( _kbhit() ) {
			if( _getch()==0x1b )
				return( 1 );
		}
		yd=(y/2*SizX)/2;
		for( x=0; x<SizX-1; x+=2 ) {
			xd=x/2;
			cg=cr=cb=cc=yg=yr=yb=yc=0;		/* FƋPx̐ώZ 4~4 */
			for( a=-1; a<=2; a++ ) {
				xx=x+a;
				for( b=-1; b<=2; b++ ) {
					yy=y+b;
					if( xx>=0 && xx<SizX && yy>=0 && yy<SizY ) {
						Sum_gdata( xx, yy, &g0, &r0, &b0 );
						ydt[a+1+(b+1)*4]=CVY2( b0, r0, g0 );
						cg+=g0;
						cr+=r0;
						cb+=b0;
						cc++;
						if( a>=0 && a<=1 && b>=0 && b<=1 ) {
							yg+=g0;
							yr+=r0;
							yb+=b0;
							yc++;
						}
					}
					else
						ydt[a+1+(b+1)*4]=-1;
				}
			}
			sum_ydata( ydt, &bc, &bcc );
			
			hi=( bcc>0 )?(bc/bcc)/10000 : 0;
			cr/=cc;
			cg/=cc;
			cb/=cc;
			yr/=yc;
			yg/=yc;
			yb/=yc;

			make_color( &cb, &cr, &cg, yb, yr, yg, hi );

			/* Ff[^ */
			*((unsigned short *)Ddata+xd+yd)=G_color32k(cg, cr, cb);
		}
	}
	printf( "%sϊI܂(100)\n", Nowfile );
	
	return( 0 );
}


/* F쐬 */
void make_color( int *bb, int *rr, int *gg, int bb1, int rr1, int gg1, int hi ) {
int y,cr,cb,y0,b;

		cr=CVCR( *bb, *rr, *gg );				/* YC */
		cb=CVCB( *bb, *rr, *gg );
		y=CVY( bb1, rr1, gg1 );
		y0=CVY( *bb, *rr, *gg );

		b=abs(*rr-rr1)+abs(*bb-bb1)+abs(*gg-gg1);
		b=1000/(b+1);
		b+=Blur;
		if( b>100 )
			b=100;
		y+=(y0-y)*b/100;		/* ɂ݋̒ */
		
		y+=hi*Tone/100;			/* F̒ */

		*bb=CVB( cr, cb, y );					/* RGBF */
		*bb=( *bb>=0 )?(*bb+5000)/10000 : 0;
		*rr=CVR( cr, cb, y );
		*rr=( *rr>=0 )?(*rr+5000)/10000 : 0;
		*gg=CVG( cr, cb, y );
		*gg=( *gg>=0 )?(*gg+5000)/10000 : 0;

		if( *bb>255 )
			*bb=255;
		if( *rr>255 )
			*rr=255;
		if( *gg>255 )
			*gg=255;

}


/* pbg */
void adj_palette( char *pal, int col ) {
int i;
								/* Tiff̃pbgf[^̒ */
	for( i=0; i<col*3; i++ ) {
		*((unsigned short *)pal+i)=*((unsigned short *)pal+i)>>8;
	}
}


/* 16Ff[^擾 */
void sum_gdata16( int x, int y, int *cg, int *cr, int *cb ) {
int cc;
	cc=Gdata[(x+y*SizX)/2];
	if( x&1 )
		cc=cc>>4;
	else
		cc=cc&15;
	*cb=Pal16->blue[cc];	/* pbgɂFϊ */
	*cr=Pal16->red[cc];
	*cg=Pal16->green[cc];
}


/* 256Ff[^擾 */
void sum_gdata256( int x, int y, int *cg, int *cr, int *cb ) {
int cc;
	cc=Gdata[x+y*SizX];
	*cb=Pal256->blue[cc];	/* pbgɂFϊ */
	*cr=Pal256->red[cc];
	*cg=Pal256->green[cc];
}


/* Pxf[^擾 */
void sum_ydata( int *ydt, int *sum, int *cnt ) {
int i,a,b,k,yc;

	*sum=*cnt=0;
	for( a=1; a<=2; a++ ) {
		for( b=1; b<=2; b++ ) {
			yc=ydt[a+b*4];						/* Ώۓ_̋Px */
			for( i=0; i<4; i++ ) {
				k=ydt[a+DirX[i]+(b+DirY[i])*4];	/* אړ_̋Px */
				if( k>=0 ) {
					k=yc-k;
					if( k>=0 ) {	/* Ώۓ_̕Px */
						*sum+=k;
						(*cnt)++;
					}
				}
			}
		}
	}
}
